package ru.landgrafhomyak.db.skeleton1.api.errors

import kotlinx.coroutines.CopyableThrowable
import kotlinx.coroutines.ExperimentalCoroutinesApi
import ru.landgrafhomyak.db.skeleton1.api.ReflectionApi

@OptIn(ExperimentalCoroutinesApi::class)
@ReflectionApi
public open class InternalDriverException : RuntimeException, CopyableThrowable<InternalDriverException> {
	public constructor() : super()
	public constructor(message: String?) : super(message)
	public constructor(message: String?, cause: Throwable?) : super(message, cause)
	public constructor(cause: Throwable?) : super(cause)


	override fun createCopy(): InternalDriverException? {
		if (this::class !== InternalDriverException::class)
			return null

		return InternalDriverException(this.message, this.cause)
	}
}