package ru.landgrafhomyak.db.skeleton1.api.errors

import kotlinx.coroutines.CopyableThrowable
import kotlinx.coroutines.ExperimentalCoroutinesApi
import ru.landgrafhomyak.db.skeleton1.api.ReflectionApi

@OptIn(ExperimentalCoroutinesApi::class)
@ReflectionApi
public open class SchemaDefinitionException : RuntimeException, CopyableThrowable<SchemaDefinitionException> {
	public constructor() : super()
	public constructor(message: String?) : super(message)
	public constructor(message: String?, cause: Throwable?) : super(message, cause)
	public constructor(cause: Throwable?) : super(cause)

	override fun createCopy(): SchemaDefinitionException? {
		if (this::class !== SchemaDefinitionException::class)
			return null

		return SchemaDefinitionException(this.message, this.cause)
	}
}