package ru.landgrafhomyak.db.skeleton1.api.module

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.skeleton1.api.LowLevelApi
import ru.landgrafhomyak.db.skeleton1.api.ObjectClass
import ru.landgrafhomyak.db.skeleton1.api.statement.RawStatement
import ru.landgrafhomyak.db.skeleton1.api.statement._Statement
import ru.landgrafhomyak.db.skeleton1.api.table.Table
import ru.landgrafhomyak.db.skeleton1.api.runtime.InputRow


public interface ModuleConstructorScope<mUE : Any> {
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("rootNs")
	public val rootNameNode: NameNode<mUE>

	public fun <tUE : Any> createTable(
		lifeTime: Table.LifeTime = Table.LifeTime.DATABASE_SCOPE,
		location: NameNode<mUE>,
		initializer: Table.Constructor<tUE>
	): Table<tUE, mUE>

	public fun moduleScopedObject(
		location: NameNode<mUE>,
		metadata: ObjectClass.ImplementationsProvider
	): ModuleScopedObject<mUE>

	public fun <smUE : Any> substituteModule(rootNode: NameNode<mUE>, template: Module.Template<smUE>): Module<smUE>

	public fun nameNode(parent: NameNode<mUE>, name: String): NameNode<mUE>

	public fun addStatement(stmt: _Statement.Void2Void<*>)
	public fun addStatement(stmt: RawStatement.Void2Void.ImplementationsProvider<*>)

	@LowLevelApi
	public fun <sUE : Any> _addStatement(stmt: _Statement.Params2Void<sUE>): InputRow._Scope<sUE, Unit>

	@LowLevelApi
	public fun <sUE : Any> _addStatement(stmt: RawStatement.Params2Void.ImplementationsProvider<sUE>): InputRow._Scope<sUE, Unit>
}