package ru.landgrafhomyak.db.skeleton1.api.runtime

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.skeleton1.api.LowLevelApi
import ru.landgrafhomyak.db.skeleton1.api.statement.OutputColumn

public interface OutputRow<qUE : Any> {
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("uExt")
	public val uExt: qUE

	public operator fun <RuntimeType> get(c: OutputColumn<RuntimeType, qUE>): RuntimeType

	public operator fun get(c: OutputColumn<Byte, qUE>): Byte = this.get<Byte>(c)
	public operator fun get(c: OutputColumn<UByte, qUE>): UByte = this.get<UByte>(c)
	public operator fun get(c: OutputColumn<Short, qUE>): Short = this.get<Short>(c)
	public operator fun get(c: OutputColumn<UShort, qUE>): UShort = this.get<UShort>(c)
	public operator fun get(c: OutputColumn<Int, qUE>): Int = this.get<Int>(c)
	public operator fun get(c: OutputColumn<UInt, qUE>): UInt = this.get<UInt>(c)
	public operator fun get(c: OutputColumn<Long, qUE>): Long = this.get<Long>(c)
	public operator fun get(c: OutputColumn<ULong, qUE>): ULong = this.get<ULong>(c)
	public operator fun get(c: OutputColumn<Char, qUE>): Char = this.get<Char>(c)
	public operator fun get(c: OutputColumn<Boolean, qUE>): Boolean = this.get<Boolean>(c)

	@Suppress("ClassName")
	@LowLevelApi
	public interface _Scope<qUE : Any,out Next> : OutputRow<qUE> {
		@Suppress("FunctionName")
		@LowLevelApi
		public suspend fun _finish(): Next

		@Suppress("FunctionName")
		@LowLevelApi
		public suspend fun _abort()
	}

	@Suppress("ClassName")
	@LowLevelApi
	public interface _Iterator<qUE : Any, out Next> : _Scope<qUE, Next>, OutputRow<qUE> {
		@Suppress("FunctionName")
		@LowLevelApi
		public suspend fun _next(): Boolean

		@Suppress("FunctionName")
		@LowLevelApi
		public override suspend fun _abort()

		@Suppress("FunctionName")
		@LowLevelApi
		public override suspend fun _finish(): Next
	}
}