package ru.landgrafhomyak.db.skeleton1.api.statement

import ru.landgrafhomyak.db.skeleton1.api.Driver

public interface RawStatement<sUE : Any?> : _Statement<sUE> {
	public override val uExt: sUE

	public interface Void2Void<sUE : Any?> : RawStatement<sUE>, _Statement.Void2Void<sUE> {
		override val uExt: sUE

		public interface Constructor<@Suppress("unused") sUE : Any?>

		public interface ImplementationsProvider<USER_EXTENSION : Any?> {
			public fun provideStatementImplementations_void2void(scope: Scope<USER_EXTENSION>)

			public interface Scope<USER_EXTENSION : Any?> {
				@Suppress("ERROR_SUPPRESSION", "BOUNDS_NOT_ALLOWED_IF_BOUNDED_BY_TYPE_PARAMETER", "INCONSISTENT_TYPE_PARAMETER_BOUNDS")
				public fun <STATEMENT_CONSTRUCTOR, STATEMENT_CONSTRUCTOR_UNBOUND> addImplementation(
					driver: Driver<*, STATEMENT_CONSTRUCTOR_UNBOUND, *, *, *, *, *, *, *, *>,
					constructor: STATEMENT_CONSTRUCTOR
				) where STATEMENT_CONSTRUCTOR_UNBOUND : Constructor<*>,
						STATEMENT_CONSTRUCTOR : Constructor<USER_EXTENSION>,
						STATEMENT_CONSTRUCTOR : STATEMENT_CONSTRUCTOR_UNBOUND
			}
		}
	}

	public interface Void2Row<sUE : Any> : RawStatement<sUE>, _Statement.Void2Row<sUE> {
		override val uExt: sUE

		public interface Constructor<sUE : Any> {
			public fun declareIO(scope: StatementIODeclarationScope.Output<sUE>): sUE
		}

		public interface ImplementationsProvider<USER_EXTENSION : Any> {
			public fun provideStatementImplementations_void2row(scope: Scope<USER_EXTENSION>)

			public interface Scope<USER_EXTENSION : Any> {
				@Suppress("ERROR_SUPPRESSION", "BOUNDS_NOT_ALLOWED_IF_BOUNDED_BY_TYPE_PARAMETER", "INCONSISTENT_TYPE_PARAMETER_BOUNDS")
				public fun <STATEMENT_CONSTRUCTOR, STATEMENT_CONSTRUCTOR_UNBOUND> addImplementation(
					driver: Driver<*, *, STATEMENT_CONSTRUCTOR_UNBOUND, *, *, *, *, *, *, *>,
					constructor: STATEMENT_CONSTRUCTOR
				) where STATEMENT_CONSTRUCTOR_UNBOUND : Constructor<*>,
						STATEMENT_CONSTRUCTOR : Constructor<USER_EXTENSION>,
						STATEMENT_CONSTRUCTOR : STATEMENT_CONSTRUCTOR_UNBOUND
			}
		}
	}

	public interface Void2RowOrNull<sUE : Any> : RawStatement<sUE>, _Statement.Void2RowOrNull<sUE> {
		override val uExt: sUE

		public interface Constructor<sUE : Any> {
			public fun declareIO(scope: StatementIODeclarationScope.Output<sUE>): sUE
		}

		public interface ImplementationsProvider<USER_EXTENSION : Any> {
			public fun provideStatementImplementations_void2rowOrNull(scope: Scope<USER_EXTENSION>)

			public interface Scope<USER_EXTENSION : Any> {
				@Suppress("ERROR_SUPPRESSION", "BOUNDS_NOT_ALLOWED_IF_BOUNDED_BY_TYPE_PARAMETER", "INCONSISTENT_TYPE_PARAMETER_BOUNDS")
				public fun <STATEMENT_CONSTRUCTOR, STATEMENT_CONSTRUCTOR_UNBOUND> addImplementation(
					driver: Driver<*, *, *, STATEMENT_CONSTRUCTOR_UNBOUND, *, *, *, *, *, *>,
					constructor: STATEMENT_CONSTRUCTOR
				) where STATEMENT_CONSTRUCTOR_UNBOUND : Constructor<*>,
						STATEMENT_CONSTRUCTOR : Constructor<USER_EXTENSION>,
						STATEMENT_CONSTRUCTOR : STATEMENT_CONSTRUCTOR_UNBOUND
			}
		}

	}

	public interface Void2Table<sUE : Any> : RawStatement<sUE>, _Statement.Void2Table<sUE> {
		override val uExt: sUE

		public interface Constructor<sUE : Any> {
			public fun declareIO(scope: StatementIODeclarationScope.Output<sUE>): sUE
		}

		public interface ImplementationsProvider<USER_EXTENSION : Any> {
			public fun provideStatementImplementations_void2table(selector: Selector<USER_EXTENSION>)

			public interface Selector<USER_EXTENSION : Any> {
				@Suppress("ERROR_SUPPRESSION", "BOUNDS_NOT_ALLOWED_IF_BOUNDED_BY_TYPE_PARAMETER", "INCONSISTENT_TYPE_PARAMETER_BOUNDS")
				public fun <STATEMENT_CONSTRUCTOR, STATEMENT_CONSTRUCTOR_UNBOUND> addImplementation(
					driver: Driver<*, *, *, *, STATEMENT_CONSTRUCTOR_UNBOUND, *, *, *, *, *>,
					constructor: STATEMENT_CONSTRUCTOR
				) where STATEMENT_CONSTRUCTOR_UNBOUND : Constructor<*>,
						STATEMENT_CONSTRUCTOR : Constructor<USER_EXTENSION>,
						STATEMENT_CONSTRUCTOR : STATEMENT_CONSTRUCTOR_UNBOUND
			}
		}
	}

	public interface Params2Void<sUE : Any> : RawStatement<sUE>, _Statement.Params2Void<sUE> {
		override val uExt: sUE

		public interface Constructor<sUE : Any> {
			public fun declareIO(scope: StatementIODeclarationScope.Input<sUE>): sUE
		}

		public interface ImplementationsProvider<USER_EXTENSION : Any> {
			public fun provideStatementImplementations_params2void(scope: Scope<USER_EXTENSION>)

			public interface Scope<USER_EXTENSION : Any> {
				@Suppress("ERROR_SUPPRESSION", "BOUNDS_NOT_ALLOWED_IF_BOUNDED_BY_TYPE_PARAMETER", "INCONSISTENT_TYPE_PARAMETER_BOUNDS")
				public fun <STATEMENT_CONSTRUCTOR, STATEMENT_CONSTRUCTOR_UNBOUND> addImplementation(
					driver: Driver<*, *, *, *, *, STATEMENT_CONSTRUCTOR_UNBOUND, *, *, *, *>,
					constructor: STATEMENT_CONSTRUCTOR
				) where STATEMENT_CONSTRUCTOR_UNBOUND : Constructor<*>,
						STATEMENT_CONSTRUCTOR : Constructor<USER_EXTENSION>,
						STATEMENT_CONSTRUCTOR : STATEMENT_CONSTRUCTOR_UNBOUND
			}
		}
	}

	public interface Params2Row<sUE : Any> : RawStatement<sUE>, _Statement.Params2Row<sUE> {
		override val uExt: sUE

		public interface Constructor<sUE : Any> {
			public fun declareIO(scope: StatementIODeclarationScope.InputOutput<sUE>): sUE
		}

		public interface ImplementationsProvider<USER_EXTENSION : Any> {
			public fun provideStatementImplementations_params2row(scope: Scope<USER_EXTENSION>)

			public interface Scope<USER_EXTENSION : Any> {
				@Suppress("ERROR_SUPPRESSION", "BOUNDS_NOT_ALLOWED_IF_BOUNDED_BY_TYPE_PARAMETER", "INCONSISTENT_TYPE_PARAMETER_BOUNDS")
				public fun <STATEMENT_CONSTRUCTOR, STATEMENT_CONSTRUCTOR_UNBOUND> addImplementation(
					driver: Driver<*, *, *, *, *, *, STATEMENT_CONSTRUCTOR_UNBOUND, *, *, *>,
					constructor: STATEMENT_CONSTRUCTOR
				) where STATEMENT_CONSTRUCTOR_UNBOUND : Constructor<*>,
						STATEMENT_CONSTRUCTOR : Constructor<USER_EXTENSION>,
						STATEMENT_CONSTRUCTOR : STATEMENT_CONSTRUCTOR_UNBOUND
			}
		}
	}

	public interface Params2RowOrNull<sUE : Any> : RawStatement<sUE>, _Statement.Params2RowOrNull<sUE> {
		override val uExt: sUE

		public interface Constructor<sUE : Any> {
			public fun declareIO(scope: StatementIODeclarationScope.InputOutput<sUE>): sUE
		}

		public interface ImplementationsProvider<USER_EXTENSION : Any> {
			public fun provideStatementImplementations_params2rowOrNull(scope: Scope<USER_EXTENSION>)

			public interface Scope<USER_EXTENSION : Any> {
				@Suppress("ERROR_SUPPRESSION", "BOUNDS_NOT_ALLOWED_IF_BOUNDED_BY_TYPE_PARAMETER", "INCONSISTENT_TYPE_PARAMETER_BOUNDS")
				public fun <STATEMENT_CONSTRUCTOR, STATEMENT_CONSTRUCTOR_UNBOUND> addImplementation(
					driver: Driver<*, *, *, *, *, *, *, STATEMENT_CONSTRUCTOR_UNBOUND, *, *>,
					constructor: STATEMENT_CONSTRUCTOR
				) where STATEMENT_CONSTRUCTOR_UNBOUND : Constructor<*>,
						STATEMENT_CONSTRUCTOR : Constructor<USER_EXTENSION>,
						STATEMENT_CONSTRUCTOR : STATEMENT_CONSTRUCTOR_UNBOUND
			}
		}
	}

	public interface Params2Table<sUE : Any> : RawStatement<sUE>, _Statement.Params2Table<sUE> {
		override val uExt: sUE

		public interface Constructor<sUE : Any> {
			public fun declareIO(scope: StatementIODeclarationScope.InputOutput<sUE>): sUE
		}

		public interface ImplementationsProvider<USER_EXTENSION : Any> {
			public fun provideStatementImplementations_params2table(scope: Scope<USER_EXTENSION>)

			public interface Scope<USER_EXTENSION : Any> {
				@Suppress("ERROR_SUPPRESSION", "BOUNDS_NOT_ALLOWED_IF_BOUNDED_BY_TYPE_PARAMETER", "INCONSISTENT_TYPE_PARAMETER_BOUNDS")
				public fun <STATEMENT_CONSTRUCTOR, STATEMENT_CONSTRUCTOR_UNBOUND> addImplementation(
					driver: Driver<*, *, *, *, *, *, *, *, STATEMENT_CONSTRUCTOR_UNBOUND, *>,
					constructor: STATEMENT_CONSTRUCTOR
				) where STATEMENT_CONSTRUCTOR_UNBOUND : Constructor<*>,
						STATEMENT_CONSTRUCTOR : Constructor<USER_EXTENSION>,
						STATEMENT_CONSTRUCTOR : STATEMENT_CONSTRUCTOR_UNBOUND
			}
		}
	}
}