package ru.landgrafhomyak.db.skeleton1.api.table

import ru.landgrafhomyak.db.skeleton1.api.LowLevelApi
import ru.landgrafhomyak.db.skeleton1.api.DatabaseType
import ru.landgrafhomyak.db.skeleton1.api.ObjectClass
import ru.landgrafhomyak.db.skeleton1.api.statement.RawStatement
import ru.landgrafhomyak.db.skeleton1.api.statement._Statement
import ru.landgrafhomyak.db.skeleton1.api.runtime.InputRow


public interface TableConstructorScope<tUE : Any> {
	public fun <RT> column(name: String, type: DatabaseType.ImplementationsProvider<RT>): Column<RT, tUE>

	public fun <RT> column(
		name: String, type: DatabaseType.ImplementationsProvider<RT>,
		alterCreateColumn: _Statement.Void2Void<*>
	): Column<RT, tUE>
	public fun <RT> column(
		name: String, type: DatabaseType.ImplementationsProvider<RT>,
		alterCreateColumn: RawStatement.Void2Void.ImplementationsProvider<*>
	): Column<RT, tUE>

	@LowLevelApi
	public fun <RT, sUE : Any> _column(
		name: String, type: DatabaseType.ImplementationsProvider<RT>,
		alterCreateColumn: _Statement.Void2Void<sUE>
	): InputRow._Scope<sUE, Column<RT, tUE>>

	@LowLevelApi
	public fun <RT, sUE : Any> _column(
		name: String, type: DatabaseType.ImplementationsProvider<RT>,
		alterCreateColumn: RawStatement.Params2Void.ImplementationsProvider<sUE>
	): InputRow._Scope<sUE, Column<RT, tUE>>

	public fun tableScopedObject(name: String, metadata: ObjectClass.ImplementationsProvider): TableScopedObject<tUE>

	public fun addAlterStatement(stmt: _Statement.Void2Void<*>)
	public fun addAlterStatement(stmt: RawStatement.Void2Void.ImplementationsProvider<*>)

	@LowLevelApi
	public fun <sUE : Any> _addAlterStatement(stmt: _Statement.Void2Void<sUE>): InputRow._Scope<sUE, Unit>

	@LowLevelApi
	public fun <sUE : Any> _addAlterStatement(stmt: RawStatement.Params2Void.ImplementationsProvider<sUE>): InputRow._Scope<sUE, Unit>
}