package ru.landgrafhomyak.db.skeleton1.api.table

import ru.landgrafhomyak.db.skeleton1.api.LowLevelApi
import ru.landgrafhomyak.db.skeleton1.api.statement.RawStatement
import ru.landgrafhomyak.db.skeleton1.api.statement._Statement
import ru.landgrafhomyak.db.skeleton1.api.runtime.InputRow

public interface TableUpgradeScope<tnUE : Any, toUE : Any> : TableConstructorScope<tnUE> {
	public fun <RT> keepColumn(c: Column<RT, toUE>): Column<RT, tnUE>
	public fun <RT> renameColumn(c: Column<RT, toUE>, newName: String): Column<RT, tnUE>
	public fun deleteColumn(c: Column<*, toUE>)
	public fun <RT> deleteColumnAfterUpgrade(c: Column<RT, toUE>): Column<RT, tnUE>

	public fun keepTableScopedObject(obj: TableScopedObject<toUE>): TableScopedObject<tnUE>
	public fun renameTableScopedObject(obj: TableScopedObject<toUE>, newName: String): TableScopedObject<tnUE>
	public fun deleteTableScopedObject(obj: TableScopedObject<toUE>)
	public fun deleteTableScopedObjectAfterUpgrade(obj: TableScopedObject<toUE>): TableScopedObject<tnUE>

	public fun addAlterStatementAfterUpgrade(stmt: _Statement.Void2Void<*>)
	public fun addAlterStatementAfterUpgrade(stmt: RawStatement.Void2Void.ImplementationsProvider<*>)

	@LowLevelApi
	public fun <sUE : Any> _addAlterStatementAfterUpgrade(stmt: _Statement.Params2Void<sUE>): InputRow._Scope<sUE, Unit>

	@LowLevelApi
	public fun <sUE : Any> _addAlterStatementAfterUpgrade(stmt: RawStatement.Params2Void.ImplementationsProvider<sUE>): InputRow._Scope<sUE, Unit>
}